﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using CommonBehaviors.Actions;
namespace FarmMage
{
    public class Main : CombatRoutine
    {
        public override string Name { get { return "Mage Farm Routine by Pasterke"; } }
        public override WoWClass Class { get { return WoWClass.Mage; } }
        public static LocalPlayer Me { get { return StyxWoW.Me; } }

        public string lastSpell { get; set; }
        public override bool NeedRest
        {
            get
            {
                if (Me.HasAura("Food") || Me.HasAura("Drink")) return false;
                if (Me.ManaPercent <= 50) { Styx.CommonBot.Rest.Feed(); }
                return false;
            }
        }

        public override void Pull()
        {
            if (Me.HasAura("Food") || Me.HasAura("Drink")) return;
            if (Me.CurrentTarget != null && (Me.CurrentTarget.Distance > 39 || !Me.CurrentTarget.InLineOfSight))
            {
                Navigator.MoveTo(Me.CurrentTarget.Location);
                return;
            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.Distance <= 39)
            {
                Navigator.PlayerMover.MoveStop();
            }
            if (Me.CurrentTarget != null && !Me.IsSafelyFacing(Me.CurrentTarget))
            {
                Me.CurrentTarget.Face();
            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.Distance <= 39 && SpellManager.CanCast("Ice Lance"))
            {
                SpellManager.Cast("Ice Lance", Me.CurrentTarget);
                lastSpell = "Ice Lance";
            }
        }

        public override bool NeedPreCombatBuffs
        {
            get
            {
                if (!HaveMageFood && lastSpell != "Conjure Refreshment")
                { 
                    SpellManager.Cast("Conjure Refreshment");
                    lastSpell = "Conjure Refreshment";
                }
                if (!Me.HasAura("Arcane Brilliance") 
                    && !Me.Mounted
                    && lastSpell != "Arcane Brilliance"
                    && SpellManager.CanCast("Arcane Brilliance", Me)) 
                { 
                    SpellManager.Cast("Arcane Brilliance", Me);
                    lastSpell = "Arcane Brilliance";
                }
                if (!Me.GotAlivePet 
                    && !Me.Mounted
                    && lastSpell != "Summon Water Elemental"
                    && SpellManager.CanCast("Summon Water Elemental")) 
                { 
                    SpellManager.Cast("Summon Water Elemental");
                    lastSpell = "Summon Water Elemental";
                }
                return false;
            }
        }

        public override void Combat()
        {
            Rotation();
        }

        public void Rotation()
        {
            if (Me.IsChanneling || Me.IsCasting) return;

            if (Me.HasAura("Food") || Me.HasAura("Drink")) return;

            if (Me.Mounted) return;

            if (Me.Pet == null 
                && !Me.Mounted 
                && lastSpell != "Summon Water Elemental"
                && SpellManager.CanCast("Summon Water Elemental")) 
            { 
                SpellManager.Cast("Summon Water Elemental");
                lastSpell = "Summon Water Elemental";
                return; 
            }

            if ((Me.CurrentTarget != null || Me.CurrentTarget.IsDead) && meleeAttackers != null)
            {
                Me.ClearTarget();
                meleeAttackers.Target();
            }
            if (gotTarget && (Me.CurrentTarget.Distance > 39 || !Me.CurrentTarget.InLineOfSight))
            {
                Navigator.MoveTo(Me.CurrentTarget.Location);
                return;
            }
            if (gotTarget && Me.CurrentTarget.Distance <= 39 && Me.IsMoving)
            {
                Navigator.PlayerMover.MoveStop();
                return;
            }
            if (gotTarget && !Me.IsSafelyFacing(Me.CurrentTarget))
            {
                Me.CurrentTarget.Face();
            }
            if (gotTarget
                && AddCount >= 3
                && SpellManager.HasSpell("Blizzard")
                && SpellManager.CanCast("Blizzard"))
            {
                SpellManager.Cast("Blizzard");
                SpellManager.ClickRemoteLocation(Me.CurrentTarget.Location);
            }
            if (gotTarget
                && SpellManager.CanCast("Ice Lance"))
            {
                SpellManager.Cast("Ice Lance", Me.CurrentTarget);
            }
            return;
        }

        public static bool gotTarget
        {
            get { return Me.CurrentTarget != null && Me.CurrentTarget.IsAlive && Me.CurrentTarget.CanSelect && Me.CurrentTarget.IsValid; }
        }

        public int AddCount
        {
            get
            {
                return ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Count(p => p.IsAlive
                    && p.Distance <= 35
                    && p.Combat
                    && p.IsTargetingMeOrPet);
            }
        }
        public static WoWUnit meleeAttackers
        {
            get
            {
                var t = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(p => p.Combat
                    && (p.IsTargetingMeOrPet || p.IsTargetingAnyMinion)
                    && p.Distance2DSqr <= 20).FirstOrDefault();
                return t != null ? t : null;
            }
        }
        public static bool HaveMageFood 
        {
            get 
            {
                foreach (WoWItem item in Me.BagItems)
                {
                    if (MageFood.Contains(item.Entry)) return true;
                }
                return false;
            }
        }
        private static HashSet<uint> MageFood = new HashSet<uint>()
        {
            65500,
            65515,
            65516,
            65517,
            43518,
            43523,
            65499,
            80610, 
            80618  
        };
                                                         
    }
}
